<?php
/**
* LDV Generator
*
* NOTICE OF LICENSE
*
* This product is licensed for one customer to use on one installation (test stores and multishop included).
* Site developer has the right to modify this module to suit their needs, but can not redistribute the module in
* whole or in part. Any other use of this module constitues a violation of the user agreement.
*
* DISCLAIMER
*
* NO WARRANTIES OF DATA SAFETY OR MODULE SECURITY
* ARE EXPRESSED OR IMPLIED. USE THIS MODULE IN ACCORDANCE
* WITH YOUR MERCHANT AGREEMENT, KNOWING THAT VIOLATIONS OF
* PCI COMPLIANCY OR A DATA BREACH CAN COST THOUSANDS OF DOLLARS
* IN FINES AND DAMAGE A STORES REPUTATION. USE AT YOUR OWN RISK.
*
*  @author    maipiusenza
*  @copyright 2015 maipiusenza
*  @license   See above
*
* maipiusenza
*/

if (!defined('_PS_VERSION_')) {
    exit;
}
/*if (!defined('_PS_VERSION_')) {
    die('Restrict Access!!');
}
*/
class LdvGenerator extends Module
{
    public function __construct()
    {
        $this->name = 'ldvgenerator';
        $this->tab = 'administration';
        $this->version = '1.9.0';
        $this->author = 'maipiusenza';
        $this->need_instance = 0;
        $this->bootstrap = true;
        $this->module_key = '06233d2fd299eae5e9f343b2120cfbc7';
    //$this->ps_versions_compliancy = array('min' => '1.5', 'max' => '1.5');
    //ZZZZZZZZZZZZZ  $this->ps_versions_compliancy = array('min' => '1.5', 'max' => '1.5');
    //$this->dependencies = array('blockcart');
 
        parent::__construct();

        $this->displayName = $this->l('LDV Generator');
        $this->description = $this->l('Super rapid service for creating shipping documents in just one click form the order details page.');

        $this->confirmUninstall = $this->l('Are you sure you want to uninstall?');

        /* Backward compatibility */
        if (_PS_VERSION_ < '1.5') {
            require(_PS_MODULE_DIR_.$this->name.'/backward_compatibility/backward.php');
        }
    }





    public function install()
    {
        return parent::install() &&

            $this->registerHook('adminOrder') &&

           $this->registerHook('actionAdminControllerSetMedia') &&

            Configuration::updateValue('LDV_POSITION', 'topRight');
    }


    public function uninstall()
    {
        if (!parent::uninstall() || !Configuration::deleteByName('LDV_POSITION')) {
            return false;
        }
        return true;
    }


    public function hookActionAdminControllerSetMedia()
    {
        if (Tools::getValue('controller') == 'AdminOrders' || Tools::getValue('tab') == 'AdminOrders') {
            $this->context->controller->addCSS($this->_path.'views/css/back.css', 'all');
            $this->context->controller->addJS($this->_path.'views/js/ldv.js');
        }
    }




    public function hookAdminOrder($params)
    {

        $order = new Order($params['id_order']);
        $customer = new Customer($order->id_customer);
        $address = new Address($order->id_address_delivery);
        $state = new State($address->id_state);
        $country = new Country($address->id_country);



// connessione al DB

        $q = "
        SELECT `product_weight`, `product_quantity`
        FROM `"._DB_PREFIX_."order_detail`
         WHERE `id_order` = " .(int)$params['id_order'];

        if ($r = Db::getInstance()->ExecuteS($q)) {
            $pesoTot =0;
            $myi=0;
            $prodSenzaPeso=0;
            foreach ($r as $row) {
                $pesoTot +=($row['product_weight']*$row['product_quantity']);
                $myi ++;
                if ($row['product_weight']<=0) {
                    $prodSenzaPeso ++;
                }
            }
        }


        $q2 = "
        SELECT `value`
        FROM `"._DB_PREFIX_."configuration`  
        WHERE `name` = 'PS_WEIGHT_UNIT'" ;
        $unitMisuraPeso= "";
        if ($r2 = Db::getInstance()->ExecuteS($q2)) {
            foreach ($r2 as $row) {
                $unitMisuraPeso = $row['value'];
            }
        }


        $nomiPS = array();

        $nomiPS[0] = "PS_nome";
        $nomiPS[1] = "PS_cognome";
        $nomiPS[2] = "PS_company";
        $nomiPS[3] = "PS_addr1";
        $nomiPS[4] = "PS_addr2";
        $nomiPS[5] = "PS_CAP";
        $nomiPS[6] = "PS_city";
        $nomiPS[7] = "PS_altro";
        $nomiPS[8] = "PS_tel1";
        $nomiPS[9] = "PS_tel2";
        $nomiPS[10] = "PS_mail";
        $nomiPS[11] = "PS_provName"; // prov nome
        $nomiPS[12] = "PS_prov"; // prrov sigla
        $nomiPS[13] = "PS_nazione"; // nazione
        $nomiPS[14] = "PS_peso";
        $nomiPS[15] = "PS_prodSenzaPeso";
        $nomiPS[16] = "PS_unitPeso";
        $nomiPS[17] = "PS_costoTot";
        $nomiPS[18] = "PS_modPagamento";


        //$nomiPS[40] = "PS_user"; // username ebay
        $nomiPS[41] = "PS_IdOrder";// per ebay (id transazione), amazon, (e ecommerce)
        $nomiPS[42] = "PS_IdVend";// ebay  (ID vendita poche cifre) - ecommerce: ORDER RIF
        $nomiPS[43] = "PS_pageName";// "ebay", "amazon", "ecommerce"... ecommerce



        $datiPS = array();

        $datiPS[0] = (string)$address->firstname;
        $datiPS[1] = (string)$address->lastname;
        $datiPS[2] = (string)$address->company;
        $datiPS[3] = (string)$address->address1;
        $datiPS[4] = (string)$address->address2;
        $datiPS[5] = (string)$address->postcode;
        $datiPS[6] = (string)$address->city;
        $datiPS[7] = (string)$address->other;
        //$datiPS[8] = (string)$address->phone;
        //$datiPS[9] = (string)$address->phone_mobile;
        $datiPS[8] =  (Tools::strlen($address->phone_mobile)<1 ? (string)$address->phone : (string)$address->phone_mobile);// CELL se disponibile, altrimenti tel
        $datiPS[9] =  (Tools::strlen($address->phone_mobile)<1 ? (string)"" : (string)$address->phone);// TEL se non usato prima o vuoto
        $datiPS[10] = (string)$customer->email;
        $datiPS[11] = (string)$state->name; // prov nome
        $datiPS[12] = (string)$state->iso_code; // prrov sigla
        $datiPS[13] = (string)$country->iso_code; // nazione
        $datiPS[14] = (string)($pesoTot+ $order->total_wrapping);
        $datiPS[15] = (string)$prodSenzaPeso;
        $datiPS[16] = (string)$unitMisuraPeso;
        if (_PS_VERSION_< "1.5") {
            $datiPS[17] = (string)$order->total_paid;
        } else {
            $datiPS[17] = (string)$order->total_paid_tax_incl;
        }
        $datiPS[18] = (string)$order->payment;

        $datiPS[41] = (string)$order->id;// per ebay (id transazione), amazon, (e ecommerce)
        // se reference è vuoto, passo orderID
        $datiPS[42] =  (Tools::strlen($order->reference)<1 ? (string)$order->id : (string)$order->reference);// ebay  (ID vendita poche cifre) - ecommerce: ORDER RIF
        $datiPS[43] = "ecomm-presta";// "ebay", "amazon", "ecommerce"...

        for ($a=0; $a<=43; $a++) {
            if (!isset($datiPS[$a])) {
                $datiPS[$a]="";
            }
        }


        $ldvPos = Configuration::get('LDV_POSITION');
        //$ldvProt = Configuration::get('LDV_PROTOCOL');
        if (_PS_VERSION_< "1.5") {
            $myStyle = 'none';
        } else {
            $myStyle = $ldvPos;
        }
        $ldvTplType = "_socket";

        $myBaseUrl = _PS_BASE_URL_SSL_.__PS_BASE_URI__;


        $flashVars = "";
        // tolgo evntuali &  andate a capo
        for ($a=0; $a<count($datiPS); $a++) {
            if (isset($datiPS[$a])) {
                $datiPS[$a] = str_replace("&", "§§§", $datiPS[$a]);
                $datiPS[$a] = str_replace("\"", "ççç", $datiPS[$a]);

                $datiPS[$a] = str_replace("\r\n", " ", $datiPS[$a]);
                $datiPS[$a] = str_replace("\r", " ", $datiPS[$a]);
                $datiPS[$a] = str_replace("\n", " ", $datiPS[$a]);
            }
        // scrivo solo se $nomiPS[$a] ha un valore
            if (isset($nomiPS[$a])) {
                if (Tools::strlen($nomiPS[$a])>0) {
                    $flashVars .= $nomiPS[$a]."=".$datiPS[$a].'&';
                }
            }
        }
        $this->context->smarty->assign(array('name'=>'LdvGenerator', 'ldvarray'=>array($myStyle, $myBaseUrl, $flashVars,$this->version, $datiPS[15])));
        if (_PS_VERSION_>= "1.5") {
            return $this->display(__FILE__, 'adminOrder'.$ldvTplType.'.tpl');
        } else {
            return $this->context->smarty->display(dirname(__FILE__).'/views/templates/hook/adminOrder'.$ldvTplType.'.tpl');
        }
    }


    public function getContent()
    {
        $output = null;

        $this->context->smarty->assign('module_dir', $this->_path);

        if (_PS_VERSION_>= "1.5") {
            if (Tools::isSubmit('submit'.$this->name)) {
                $ldv_position = (string)Tools::getValue('LDV_POSITION');

                if (!$ldv_position || empty($ldv_position) || !Validate::isGenericName($ldv_position)) {
                    $output .= $this->displayError($this->l('Invalid Configuration value'));
                } else {
                    Configuration::updateValue('LDV_POSITION', $ldv_position);
                    $output .= $this->displayConfirmation($this->l('Setting updated'));
                }
            }


            //v1.8 carco una pagina esterna
            $output .= $this->context->smarty->fetch($this->local_path.'views/templates/admin/configure.tpl');
            return $output.$this->renderForm();
        } else {
            return $output.$this->l('No configuration available for this version of prestashop');
        }
    }





// v1.8 sostituiso displayform con renderforn caricando una pagina esterna (per srivere delle spiegazioni)

    public function renderForm()
    {
        // Get default language
        $default_lang = (bool)Configuration::get('PS_LANG_DEFAULT');


        $fields_form = array();
        $fields_form[0]['form'] = array(
            'legend' => array(
                'title' => $this->l('LDV Generator Settings'),
                'icon' => 'icon-cogs'
            ),
            'input' => array(

                array(
                    'type'      => 'radio',
                    'label'     => $this->l('Box position'),
                    'desc'      => $this->l('Select the position for the LDV Generator box'),
                    'name'      => 'LDV_POSITION',
                    'required'  => false,
                    'class'     => 't',
                    'is_bool'   => false,


                    'values'    => array(
                        array(
                            'id'    => 'ldvPosizione_bRight',
                            'value' => 'bottomRight',
                            'label' => $this->l('Bottom right, always visible')
                        ),
                       array(
                           'id'    => 'ldvPosizione_bLeft',
                           'value' => 'bottomLeft',
                           'label' => $this->l('Bottom left, always visible')
                        ),
                       array(
                           'id'    => 'ldvPosizione_tRight',
                           'value' => 'topRight',
                           'label' => $this->l('Top right, always visible')
                       ),
                       array(
                           'id'    => 'ldvPosizione_tLeft',
                           'value' => 'topLeft',
                           'label' => $this->l('Top left, always visible')
                       ),
                       array(
                           'id'    => 'ldvPosizione_none',
                           'value' => 'none',
                           'label' => $this->l('don\'t change the position (you will probably need to scroll the page)')
                       )
                   ),
               ),
            ),


            'submit' => array(
            'title' => $this->l('Save'),
            'class' => 'btn btn-default pull-right'
            )

        );

        $helper = new HelperForm();

        // Module, token and currentIndex
        $helper->module = $this;
        $helper->name_controller = $this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;

        // Language
        $helper->default_form_language = $default_lang;
        $helper->allow_employee_form_lang = $default_lang;

        // Title and toolbar
        $helper->title = $this->displayName;
        $helper->show_toolbar = true;        // false -> remove toolbar
        $helper->toolbar_scroll = true;      // yes - > Toolbar is always visible on the top of the screen.
        $helper->submit_action = 'submit'.$this->name;
        $helper->toolbar_btn = array(
            'save' =>
            array(
                'desc' => $this->l('Save'),
                'href' => AdminController::$currentIndex.'&configure='.$this->name.'&save'.$this->name.
                '&token='.Tools::getAdminTokenLite('AdminModules'),
            ),
            'back' => array(
                'href' => AdminController::$currentIndex.'&token='.Tools::getAdminTokenLite('AdminModules'),
                'desc' => $this->l('Back to the list')
            )
        );


        // Load current value
        $helper->fields_value['LDV_POSITION'] = Configuration::get('LDV_POSITION');
        //$helper->fields_value['LDV_PROTOCOL'] = Configuration::get('LDV_PROTOCOL');


        return $helper->generateForm($fields_form);
    }


// FINE RENDER FORM
}
